<template>
  <Page>
    <ElForm v-show="showSearchForm" inline @submit.prevent="paging">
      <ElFormItem label="端点地址">
        <ElInput
          v-model="searchForm.endpointPath"
          placeholder="端点地址"/>
      </ElFormItem>

      <ElFormItem>
        <ElButton :icon="elIcons.Search" :loading="searching" native-type="submit" type="primary">搜索</ElButton>
        <ElButton :icon="elIcons.Refresh" :loading="searching" @click="reset">重置</ElButton>
      </ElFormItem>
    </ElForm>

    <div class="tool-bar">
      <ElButton :icon="elIcons.Plus" type="primary" @click="addHandler">新建</ElButton>
      <ElButton :icon="elIcons.Filter" type="default" @click="showSearchForm = !showSearchForm"/>
    </div>

    <ElTable v-loading="searching" :data="tableData"
      cell-class-name="table-cell"
      class="table-list"
      empty-text="暂无数据"
      header-row-class-name="table-header"
      row-key="id">
      <ElTableColumn label="请求方式" prop="requestMethod"/>
      <ElTableColumn label="路由前缀" prop="routingPath"/>
      <ElTableColumn label="端点地址" prop="endpointPath"/>
      <ElTableColumn label="访问模式" prop="accessModelTxt"/>
      <ElTableColumn label="备注" prop="memo"/>
      <ElTableColumn label="操作" width="180">
        <template #default="scope">
          <div class="action-btn">
            <ElPopconfirm
              cancel-button-text="否"
              cancel-button-type="primary"
              confirm-button-text="是"
              confirm-button-type="danger"
              placement="top"
              title="是否删除当前数据?"
              width="180"
              @confirm="delHandler(scope)">
              <template #reference>
                <ElButton :loading="deling" text type="danger">删除</ElButton>
              </template>
            </ElPopconfirm>
            <ElButton text type="primary" @click="modifyHandler(scope)">修改</ElButton>
          </div>
        </template>
      </ElTableColumn>
    </ElTable>
    <ElPagination
      v-model:current-page="searchForm.current"
      v-model:page-size="searchForm.size"
      :hide-on-single-page="false"
      :page-sizes="[10, 20, 50, 100, 500]"
      :teleported="false"
      :total="totalCount"
      layout="->, sizes, total, prev, pager, next"
      @change="paging"/>
    <EndpointForm ref="endpointForm" @edit-succ="paging"/>
  </Page>
</template>

<script lang="ts" setup>
import EndpointApi from '@/pages/sys/endpoint/endpoint-api.ts'
import EndpointForm from '@/pages/sys/endpoint/EndpointForm.vue'
import Page from '@/components/page/Page.vue'
import { elIcons } from '@/common/element/element.ts'

const totalCount = ref(0)
const tableData = ref<EndpointTypes.SearchEndpointResult[]>([])
const searchForm = ref<EndpointTypes.SearchEndpointParam>({
  current: 1,
  size: 20,
})
const searching = ref(false)
const deling = ref(false)
const showSearchForm = ref(true)
const endpointFormIns = useTemplateRef<InstanceType<typeof EndpointForm>>('endpointForm')

function showDialog(data?: EndpointTypes.SearchEndpointResult) {
  endpointFormIns.value?.open(data)
}

function delHandler({row}: { row: EndpointTypes.SearchEndpointResult }) {
  deling.value = true
  EndpointApi.del([ row.id! ])
    .then(() => {
      ElMessage.success('删除成功')
      paging()
    })
    .finally(() => {
      deling.value = false
    })
}

function modifyHandler({row}: { row: EndpointTypes.SearchEndpointResult }) {
  showDialog(row)
}

function addHandler() {
  showDialog()
}

function reset() {
  searchForm.value = {
    current: 1,
    size: 20,
  }
  paging()
}

function paging() {
  searching.value = true
  EndpointApi.paging(searchForm.value)
    .then(res => {
      totalCount.value = res.data?.total ?? 0
      tableData.value = res.data?.records ?? []
    })
    .finally(() => {
      searching.value = false
    })
}

onMounted(() => {
  paging()
})

</script>

<style lang="stylus" scoped>
.table-list {
  flex 1;
  margin 0 0 20px 0
  width 100%

  :deep(.table-header) {
    color #454C59

    th {
      background-color #EDF1F7
      font-weight 500
      position relative

      & > div {
        display flex
        gap 5px
        align-items center
      }

      &:not(:first-child) > div::before {
        position: absolute;
        top: 50%;
        left: 1px;
        width: 1px;
        background-color: #D3D7DE;
        transform: translateY(-50%);
        content: "";
        height 50%
      }
    }
  }

  :deep(.table-cell) {
    color #2F3540
  }

  .action-btn {
    width 100%
    display flex
    flex-wrap wrap

    & > button {
      margin 0
    }
  }
}

.tool-bar {
  display flex
  justify-content space-between
  margin 0 0 20px 0
}

.pagination {
  justify-content: end;
  margin: 8px;
}
</style>
